# LSattr_html_valueWithUnit

Ce type est utilisé pour la gestion des attributs dont la valeur est un entier auxquel un facteur
peut s'appliquer (par exemple : `Kilo, Méga, ...`).

```
'html_options' => array(
    'units' => array (
      '[facteur1]' => '[label unit1]',
      '[facteur2]' => '[label unit2]',
      [...]
    ),
    'translate_labels' => [booléen],
    'nb_decimals' => [number of decimals],
    'dec_point' => '[decimals point]',
    'thousands_sep' => '[thousands separator]',
    'store_integer' => [booléen],
    'round_down' => [booléen],
  )
),
...
```

- `units`

  Tableau associatif dont la clé est un entier correspondant au facteur et la valeur est le label de
  l'unité. (Par exemple : `1 => Octet, 1024 => Kilo-octet, ...`).

- `translate_labels`

  Booléen permettant d'activer/désactiver la traduction des labels (Par défaut : `True`).

- `nb_decimals`

  Le nombre de décimals à afficher en cas de nombre non-entier (Par défaut : `2`).

- `dec_point`

  Le caractère à utiliser comme séparateur de décimal (Par défaut, une virgule).

- `thousands_sep`

  Le caractère à utiliser comme séparateur de milliers (Par défaut, un espace).

- `store_integer`

  Booléen permettant d'activer/désactiver le stockage de valeurs entières (Par défaut : `True`).

- `round_down`

  Booléen permettant d'arrondir à l'entier inférieur (et non à l'entier supérieur par défaut) en cas
  de stockage de valeurs entières.
